import torch
from torch import nn

# Unlike previous classes, don't use these classes directly in train.py
# Use the functions given in main.py
# However, model definition still needs to be defined in these classes

class ConvNetModel(nn.Module):
    '''
        Your code for the model that computes classification from the inputs to the scalar value of the label.
        Classification Problem (1) in the assignment
    '''
    
    def __init__(self):
        super().__init__()
        self.model = nn.Sequential(
            nn.Conv2d(3, 32, 5, 2, 1),
            nn.ReLU(True),
            #torch.nn.GroupNorm(4,32, affine=False),
            nn.Conv2d(32, 64, 5, 2, 1),
            nn.ReLU(True),
            #torch.nn.GroupNorm(4,64, affine=False),
            nn.Conv2d(64, 128, 5, 2, 1),
            nn.ReLU(True),
            #torch.nn.GroupNorm(4,128, affine=False),
            nn.Conv2d(128, 6, 5, 2, 1),
            nn.AvgPool2d(3)
        )

    
    def forward(self, x):
        '''
        Input: a series of N input images x. size (N, 64*64*3)
        Output: a prediction of each input image. size (N,6)
        Your code here
        '''
        return self.model(x).view(-1,6)
